diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index b347c3cf2..13fda2270 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -2501,28 +2463,28 @@ public class World implements MutableWorldSource {
                 if (maxZ > Chunk.CHUNK_SIZE_Z) {
                     maxZ = Chunk.CHUNK_SIZE_Z;
                 }
-                startIndex = getChunkFromChunkCoords(chunkX, chunkZ).setChunkData(data, minX, minY, minZ, maxX, maxY, maxZ, startIndex);
-                markBlocksDirty(chunkX * Chunk.CHUNK_SIZE_X + minX, minY, chunkZ * Chunk.CHUNK_SIZE_Z + minZ, chunkX * Chunk.CHUNK_SIZE_X + maxX, maxY, chunkZ * Chunk.CHUNK_SIZE_Z + maxZ);
+                startIndex = this.getChunkFromChunkCoords(chunkX, chunkZ).setChunkData(data, minX, minY, minZ, maxX, maxY, maxZ, startIndex);
+                this.markBlocksDirty(chunkX * Chunk.CHUNK_SIZE_X + minX, minY, chunkZ * Chunk.CHUNK_SIZE_Z + minZ, chunkX * Chunk.CHUNK_SIZE_X + maxX, maxY, chunkZ * Chunk.CHUNK_SIZE_Z + maxZ);
             }
 
         }
 
     }
 
-    public byte[] getChunkData(int x, int y, int z, int xSize, int ySize, int zSize) {
-        byte[] data = new byte[xSize * ySize * zSize * 8];
-        int minChunkX = Math.floorDiv(x, Chunk.CHUNK_SIZE_X);
-        int minChunkZ = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z);
-        int maxChunkX = Math.floorDiv((x + xSize) - 1, Chunk.CHUNK_SIZE_X);
-        int maxChunkZ = Math.floorDiv((z + zSize) - 1, Chunk.CHUNK_SIZE_Z);
+    public byte[] getChunkData(final int x, final int y, final int z, final int xSize, final int ySize, final int zSize) {
+        final byte[] data = new byte[xSize * ySize * zSize * 8];
+        final int minChunkX = Math.floorDiv(x, Chunk.CHUNK_SIZE_X);
+        final int minChunkZ = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z);
+        final int maxChunkX = Math.floorDiv((x + xSize) - 1, Chunk.CHUNK_SIZE_X);
+        final int maxChunkZ = Math.floorDiv((z + zSize) - 1, Chunk.CHUNK_SIZE_Z);
         int startIndex = 0;
         int minY = y;
         int maxY = y + ySize;
         if (minY < 0) {
             minY = 0;
         }
-        if (maxY > getHeightBlocks()) {
-            maxY = getHeightBlocks();
+        if (maxY > this.getHeightBlocks()) {
+            maxY = this.getHeightBlocks();
         }
         for (int chunkX = minChunkX; chunkX <= maxChunkX; chunkX++) {
             int minX = x - chunkX * Chunk.CHUNK_SIZE_X;
@@ -2542,7 +2504,7 @@ public class World implements MutableWorldSource {
                 if (maxZ > Chunk.CHUNK_SIZE_Z) {
                     maxZ = Chunk.CHUNK_SIZE_Z;
                 }
-                startIndex = getChunkFromChunkCoords(chunkX, chunkZ).getChunkData(data, minX, minY, minZ, maxX, maxY, maxZ, startIndex);
+                startIndex = this.getChunkFromChunkCoords(chunkX, chunkZ).getChunkData(data, minX, minY, minZ, maxX, maxY, maxZ, startIndex);
             }
 
         }
@@ -2557,7 +2519,7 @@ public class World implements MutableWorldSource {
         this.levelStorage.checkSessionLock();
     }
 
-    public void setWorldTime(long l) {
+    public void setWorldTime(final long l) {
         this.levelData.setWorldTime(l);
     }
 
@@ -2583,29 +2545,29 @@ public class World implements MutableWorldSource {
         return this.levelData.getDifficulty();
     }
 
-    public void setDifficulty(Difficulty difficulty, boolean overrideLock) {
+    public void setDifficulty(final Difficulty difficulty, final boolean overrideLock) {
         this.levelData.setDifficulty(difficulty, overrideLock);
     }
 
-    public void setDifficulty(int difficulty, boolean overrideLock) {
+    public void setDifficulty(final int difficulty, final boolean overrideLock) {
         this.levelData.setDifficulty(difficulty, overrideLock);
     }
 
     public @NotNull TilePos getSpawnPoint() {
-        return new TilePos(this.levelData.getSpawnX(), this.levelData.getSpawnY(), this.levelData.getSpawnZ());
+        return new TilePos(this.levelData.getSpawnPos());
     }
 
-    public void setSpawnPoint(ChunkCoordinates chunkcoordinates) {
-        this.levelData.setSpawn(chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z);
+    public void setSpawnPoint(final ChunkCoordinates chunkcoordinates) {
+        this.levelData.getSpawnPos().set(chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z);
     }
 
-    public void joinEntityInSurroundings(Entity entity) {
-        int i = MathHelper.floor(entity.x / Chunk.CHUNK_SIZE_X);
-        int j = MathHelper.floor(entity.z / Chunk.CHUNK_SIZE_Z);
-        byte byte0 = 2;
+    public void joinEntityInSurroundings(final Entity entity) {
+        final int i = MathHelper.floor(entity.x / Chunk.CHUNK_SIZE_X);
+        final int j = MathHelper.floor(entity.z / Chunk.CHUNK_SIZE_Z);
+        final byte byte0 = 2;
         for (int k = i - byte0; k <= i + byte0; k++) {
             for (int l = j - byte0; l <= j + byte0; l++) {
-                getChunkFromChunkCoords(k, l);
+                this.getChunkFromChunkCoords(k, l);
             }
 
         }
@@ -2624,34 +2586,34 @@ public class World implements MutableWorldSource {
         return this.canMineBlock(player, new TilePos(x, y, z));
     }
 
-    public void sendTrackedEntityStatusUpdatePacket(Entity entityId, byte entityStatus) {
+    public void sendTrackedEntityStatusUpdatePacket(final Entity entityId, final byte entityStatus) {
     }
 
-    public void sendTrackedEntityStatusUpdatePacket(Entity entityId, byte entityStatus, float attackedAtYaw) {
+    public void sendTrackedEntityStatusUpdatePacket(final Entity entityId, final byte entityStatus, final float attackedAtYaw) {
     }
 
-    public void sendTrackedEntityDataPacket(Entity entity) {
+    public void sendTrackedEntityDataPacket(final Entity entity) {
 
     }
 
     public void updateEntityList() {
         this.entities.removeAll(this.entitiesToRemove);
         for (int i = 0; i < this.entitiesToRemove.size(); i++) {
-            Entity entity = this.entitiesToRemove.get(i);
-            int cX = entity.chunkCoordX;
-            int cZ = entity.chunkCoordZ;
-            if (entity.addedToChunk && isChunkLoaded(cX, cZ)) {
-                getChunkFromChunkCoords(cX, cZ).removeEntity(entity);
+            final Entity entity = this.entitiesToRemove.get(i);
+            final int cX = entity.chunkCoordX;
+            final int cZ = entity.chunkCoordZ;
+            if (entity.addedToChunk && this.isChunkLoaded(cX, cZ)) {
+                this.getChunkFromChunkCoords(cX, cZ).removeEntity(entity);
             }
         }
 
         for (int j = 0; j < this.entitiesToRemove.size(); j++) {
-            releaseEntitySkin(this.entitiesToRemove.get(j));
+            this.releaseEntitySkin(this.entitiesToRemove.get(j));
         }
 
         this.entitiesToRemove.clear();
         for (int i = 0; i < this.entities.size(); i++) {
-            Entity entity = this.entities.get(i);
+            final Entity entity = this.entities.get(i);
             if (entity.vehicle != null) {
                 if (!entity.vehicle.isRemoved() && entity.vehicle.getPassenger() == entity) {
                     continue;
@@ -2662,18 +2624,18 @@ public class World implements MutableWorldSource {
             if (!entity.removed) {
                 continue;
             }
-            int cX = entity.chunkCoordX;
-            int cZ = entity.chunkCoordZ;
-            if (entity.addedToChunk && isChunkLoaded(cX, cZ)) {
-                getChunkFromChunkCoords(cX, cZ).removeEntity(entity);
+            final int cX = entity.chunkCoordX;
+            final int cZ = entity.chunkCoordZ;
+            if (entity.addedToChunk && this.isChunkLoaded(cX, cZ)) {
+                this.getChunkFromChunkCoords(cX, cZ).removeEntity(entity);
             }
             this.entities.remove(i--);
-            releaseEntitySkin(entity);
+            this.releaseEntitySkin(entity);
         }
 
     }
 
-    public IChunkProvider getChunkProvider() {
+    public @NotNull ChunkProvider getChunkProvider() {
         return this.chunkProvider;
     }
 
@@ -2701,12 +2663,12 @@ public class World implements MutableWorldSource {
         return this.dimensionData;
     }
 
-    public void updateEnoughPlayersSleepingFlag(Player player) {
+    public void updateEnoughPlayersSleepingFlag(final Player player) {
         this.enoughPlayersSleeping = false;
         if (!this.players.isEmpty()) {
             int playersSleeping = 0;
-            int req = getPlayersRequiredToSkipNight();
-            for (Player p : this.players)
+            final int req = this.getPlayersRequiredToSkipNight();
+            for (final Player p : this.players)
                 if (p.isPlayerSleeping()) playersSleeping++;
             if (playersSleeping >= req) {
                 this.enoughPlayersSleeping = true;
@@ -2720,22 +2682,22 @@ public class World implements MutableWorldSource {
 
     protected void wakeUpAllPlayers() {
         this.enoughPlayersSleeping = false;
-        for (Player entityplayer : this.players) {
+        for (final Player entityplayer : this.players) {
             if (entityplayer.isPlayerSleeping()) {
                 entityplayer.wakeUpPlayer(false, false);
             }
         }
-        final @Nullable Weather currentWeather = getCurrentWeather();
+        final @Nullable Weather currentWeather = this.getCurrentWeather();
         if (currentWeather instanceof IPrecipitation && ((IPrecipitation) currentWeather).spawnRainParticles()) {
-            this.weatherManager.overrideWeather(this.worldType.getDefaultWeather());
+            this.weatherManager.overrideWeather(this.getWorldType().getDefaultWeather());
         }
     }
 
     public boolean areEnoughPlayersFullyAsleep() {
         if (this.enoughPlayersSleeping && !this.isClientSide) {
             int fullyAsleep = 0;
-            for (Player player : this.players) if (player.isPlayerFullyAsleep()) fullyAsleep++;
-            return fullyAsleep >= getPlayersRequiredToSkipNight() && fullyAsleep > 0;
+            for (final Player player : this.players) if (player.isPlayerFullyAsleep()) fullyAsleep++;
+            return fullyAsleep >= this.getPlayersRequiredToSkipNight() && fullyAsleep > 0;
         } else {
             return false;
         }
@@ -2766,16 +2728,16 @@ public class World implements MutableWorldSource {
         return this.isBlockBeingRainedOn(new TilePos(x, y, z));
     }
 
-    public void setSavedData(String id, SavedData savedData) {
-        this.savedDataStorage.set(id, savedData);
+    public void setSavedData(final String id, final SavedData savedData) {
+        this.getLevelStorage().getSavedDataStorage().set(id, savedData);
     }
 
-    public SavedData getSavedData(Class<? extends SavedData> saveDataClass, String id) {
-        return this.savedDataStorage.load(saveDataClass, id);
+    public SavedData getSavedData(final Class<? extends SavedData> saveDataClass, final String id) {
+        return this.getLevelStorage().getSavedDataStorage().load(saveDataClass, id);
     }
 
-    public int getUniqueDataId(String s) {
-        return this.savedDataStorage.getFreeMetadataFor(s);
+    public int getUniqueDataId(final String s) {
+        return this.getLevelStorage().getSavedDataStorage().getFreeMetadataFor(s);
     }
 
     public void playBlockEvent(final @NotNull TilePosc tilePos, final int id, final int data) {
@@ -2799,7 +2761,7 @@ public class World implements MutableWorldSource {
     }
 
     public @NotNull WorldType getWorldType() {
-        return this.worldType;
+        return this.dimensionData.getWorldType();
     }
 
     public @NotNull EntityItem dropItem(final @NotNull TilePosc tilePos, final @NotNull ItemStack itemStack) {
@@ -2819,8 +2781,8 @@ public class World implements MutableWorldSource {
         return this.dropItem(new TilePos(x, y, z), itemStack);
     }
 
-    public void sendGlobalMessage(String message) {
-        for (Player player : this.players) {
+    public void sendGlobalMessage(final String message) {
+        for (final Player player : this.players) {
             player.sendMessage(message);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index 24d906cfd..df17a90bd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -148,7 +148,7 @@ public class Chunk {
         recalcHeightmapOnly();
 
         // Generate skylight map
-        if (!this.world.worldType.hasCeiling()) {
+        if (!this.world.getWorldType().hasCeiling()) {
             for (int x = 0; x < CHUNK_SIZE_X; x++) {
                 for (int z = 0; z < CHUNK_SIZE_Z; z++) {
                     int skyLightValue = 15;
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index 8513989ec..3591baf06 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -135,7 +135,7 @@ public class ChunkCache
 
     @Override
     public float getLightBrightness(final @NotNull TilePosc tilePos) {
-        return this.world.worldType.getBrightnessRamp()[this.getBlockLightValue(tilePos)];
+        return this.world.getWorldType().getBrightnessRamp()[this.getBlockLightValue(tilePos)];
     }
 
     public int getBlockLightValue(final @NotNull TilePosc tilePos) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/IChunkLoader.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoader.java
similarity index 96%
rename from game/core/src/main/java/net/minecraft/core/world/chunk/IChunkLoader.java
rename to game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoader.java
index ba2d08b41..96b6b1048 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/IChunkLoader.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoader.java
@@ -4,7 +4,7 @@ import net.minecraft.core.world.World;
 
 import java.io.IOException;
 
-public interface IChunkLoader
+public interface ChunkLoader
 {
     /**
      * Loads a chunk into memory.
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
index 11196739e..8d9780774 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
@@ -34,7 +34,7 @@ import java.util.Arrays;
 import java.util.List;
 
 public class ChunkLoaderLegacy
-    implements IChunkLoader
+    implements ChunkLoader
 {
     private static final Logger LOGGER = LogUtils.getLogger();
     public ChunkLoaderLegacy(File worldDir, boolean createIfNecessary)
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java
index b79a94178..4d9a5f59f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java
@@ -13,7 +13,7 @@ import java.io.*;
 import java.util.zip.ZipException;
 
 public class ChunkLoaderRegion
-    implements IChunkLoader
+    implements ChunkLoader
 {
     private static final Logger LOGGER = LogUtils.getLogger();
     private final File worldDir;
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java
index a55c108ce..995322c38 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java
@@ -13,7 +13,7 @@ import java.util.concurrent.locks.Lock;
 import java.util.concurrent.locks.ReentrantLock;
 
 public class ChunkLoaderRegionAsync
-    implements IChunkLoader
+    implements ChunkLoader
 {
     private static final Logger LOGGER = LogUtils.getLogger();
     private static final Queue<Chunk> chunksToSave = new LinkedList<>();
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/provider/IChunkProvider.java b/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProvider.java
similarity index 71%
rename from game/core/src/main/java/net/minecraft/core/world/chunk/provider/IChunkProvider.java
rename to game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProvider.java
index 5068c601c..7e370efbd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/provider/IChunkProvider.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProvider.java
@@ -3,46 +3,47 @@ package net.minecraft.core.world.chunk.provider;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkPosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public interface IChunkProvider {
+public interface ChunkProvider {
 
     @Deprecated
     default boolean isChunkLoaded(int chunkX, int chunkZ) {
         return isChunkLoaded(new ChunkPos(chunkX, chunkZ));
     }
-    boolean isChunkLoaded(@NotNull ChunkPos chunkPos);
+    boolean isChunkLoaded(@NotNull ChunkPosc chunkPos);
 
     @Deprecated
     default @NotNull Chunk provideChunk(int chunkX, int chunkZ) {
         return provideChunk(new ChunkPos(chunkX, chunkZ), true);
     }
-    @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority);
+    @NotNull Chunk provideChunk(@NotNull ChunkPosc chunkPos, boolean priority);
 
     @Deprecated
     default @NotNull Chunk prepareChunk(int chunkX, int chunkZ) {
         return prepareChunk(new ChunkPos(chunkX, chunkZ), true);
     }
-    @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority);
+    @NotNull Chunk prepareChunk(@NotNull ChunkPosc chunkPos, boolean priority);
 
     @Deprecated
     default void regenerateChunk(int chunkX, int chunkZ) {
         regenerateChunk(new ChunkPos(chunkX, chunkZ));
     }
-    void regenerateChunk(@NotNull ChunkPos chunkPos);
+    void regenerateChunk(@NotNull ChunkPosc chunkPos);
 
     @Deprecated
-    default void populate(IChunkProvider chunkProvider, int chunkX, int chunkZ) {
+    default void populate(ChunkProvider chunkProvider, int chunkX, int chunkZ) {
         populate(new ChunkPos(chunkX, chunkZ));
     }
-    void populate(@NotNull ChunkPos chunkPos);
+    void populate(@NotNull ChunkPosc chunkPos);
 
     @Deprecated
     default void setCurrentChunkOver(int chunkX, int chunkZ) {
         setCurrentChunkOver(new ChunkPos(chunkX, chunkZ));
     }
-    void setCurrentChunkOver(@NotNull ChunkPos chunkPos);
+    void setCurrentChunkOver(@NotNull ChunkPosc chunkPos);
 
     boolean saveChunks(boolean saveImmediately, @Nullable ProgressListener progressListener);
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProviderThreaded.java b/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProviderThreaded.java
index 00f8aaf2f..8ffa47a9e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProviderThreaded.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProviderThreaded.java
@@ -7,9 +7,10 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
-import net.minecraft.core.world.chunk.IChunkLoader;
+import net.minecraft.core.world.chunk.ChunkLoader;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkPosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
@@ -23,13 +24,13 @@ import java.util.Map;
 import java.util.Set;
 import java.util.concurrent.atomic.AtomicBoolean;
 
-public class ChunkProviderThreaded implements IChunkProvider {
+public class ChunkProviderThreaded implements ChunkProvider {
     protected static final Logger LOGGER = LogUtils.getLogger();
     protected static final @NotNull ChunkPos MIN_POS = new ChunkPos(Integer.MIN_VALUE, Integer.MIN_VALUE);
 
     protected final @NotNull Chunk empty;
     protected final @NotNull World world;
-    protected final @NotNull IChunkLoader chunkLoader;
+    protected final @NotNull ChunkLoader chunkLoader;
     protected final @NotNull ChunkGenerator chunkGenerator;
     protected final @NotNull ChunkGenThread genThread;
 
@@ -44,7 +45,7 @@ public class ChunkProviderThreaded implements IChunkProvider {
 
     protected int tickCount = 0;
 
-    public ChunkProviderThreaded(@NotNull World world, @NotNull IChunkLoader chunkLoader, @NotNull ChunkGenerator chunkGenerator) {
+    public ChunkProviderThreaded(@NotNull World world, @NotNull ChunkLoader chunkLoader, @NotNull ChunkGenerator chunkGenerator) {
         this.world = world;
         this.chunkLoader = chunkLoader;
         this.chunkGenerator = chunkGenerator;
@@ -59,7 +60,7 @@ public class ChunkProviderThreaded implements IChunkProvider {
     }
 
     @Override
-    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
+    public boolean isChunkLoaded(@NotNull ChunkPosc chunkPos) {
         if (chunkPos.equals(this.lastQueriedChunkPos)) return true;
         boolean isLoaded;
         synchronized (this.loadedChunks) {
@@ -73,7 +74,7 @@ public class ChunkProviderThreaded implements IChunkProvider {
     }
 
     @Override
-    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+    public @NotNull Chunk provideChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
         if (chunkPos.equals(this.lastQueriedChunkPos)) return this.lastQueriedChunk;
 
         Chunk chunk;
@@ -81,7 +82,7 @@ public class ChunkProviderThreaded implements IChunkProvider {
             chunk = this.loadedChunks.get(chunkPos);
         }
         if (chunk != null) {
-            this.lastQueriedChunkPos = chunkPos;
+            this.lastQueriedChunkPos = new ChunkPos(chunkPos);
             this.lastQueriedChunk = chunk;
             if (!chunk.isTerrainPopulated) {
                 handleDecoration(chunk);
@@ -101,17 +102,17 @@ public class ChunkProviderThreaded implements IChunkProvider {
     }
 
     @Override
-    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
         return provideChunk(chunkPos, priority);
     }
 
     @Override
-    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
+    public void regenerateChunk(@NotNull ChunkPosc chunkPos) {
         throw new UnsupportedOperationException();
     }
 
     @Override
-    public void populate(@NotNull ChunkPos chunkPos) {
+    public void populate(@NotNull ChunkPosc chunkPos) {
         Chunk chunk = provideChunk(chunkPos, true);
         decorate(chunk);
     }
@@ -129,8 +130,8 @@ public class ChunkProviderThreaded implements IChunkProvider {
     }
 
     @Override
-    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
-        this.chunkOver = chunkPos;
+    public void setCurrentChunkOver(@NotNull ChunkPosc chunkPos) {
+        this.chunkOver = new ChunkPos(chunkPos);
     }
 
     @Override
@@ -284,11 +285,11 @@ public class ChunkProviderThreaded implements IChunkProvider {
         return true;
     }
 
-    protected boolean isChunkValid(@NotNull ChunkPos chunkPos) {
+    protected boolean isChunkValid(@NotNull ChunkPosc chunkPos) {
         int rd = this.world.renderDistance() + 1;
         if (this.chunkOver != null) {
-            int dx = this.chunkOver.x - chunkPos.x;
-            int dz = this.chunkOver.z - chunkPos.z;
+            int dx = this.chunkOver.x - chunkPos.x();
+            int dz = this.chunkOver.z - chunkPos.z();
             if (dx <= 2 && dx >= -2 && dz <= 2 && dz >= -2) {
                 return true;
             }
@@ -300,8 +301,8 @@ public class ChunkProviderThreaded implements IChunkProvider {
                 Player player = players.get(i);
                 int pCX = ((int) player.x >> 4);
                 int pCZ = ((int) player.z >> 4);
-                int dx = pCX - chunkPos.x;
-                int dz = pCZ - chunkPos.z;
+                int dx = pCX - chunkPos.x();
+                int dz = pCZ - chunkPos.z();
                 if (dx <= rd && dx >= -rd && dz <= rd && dz >= -rd) {
                     return true;
                 }
@@ -310,16 +311,16 @@ public class ChunkProviderThreaded implements IChunkProvider {
         return false;
     }
 
-    private @NotNull Chunk loadChunk(@NotNull ChunkPos chunkPos) {
+    private @NotNull Chunk loadChunk(@NotNull ChunkPosc chunkPos) {
         try {
-            Chunk chunk = this.chunkLoader.loadChunk(this.world, chunkPos.x, chunkPos.z);
+            Chunk chunk = this.chunkLoader.loadChunk(this.world, chunkPos.x(), chunkPos.z());
             if (chunk == null) {
-                chunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
+                chunk = this.chunkGenerator.generate(chunkPos.x(), chunkPos.z());
                 chunk.fixMissingBlocks();
             }
             return chunk;
         } catch (Exception exception) {
-            LOGGER.error("Error loading chunk at X:{}, Z:{}", chunkPos.x, chunkPos.z, exception);
+            LOGGER.error("Error loading chunk at X:{}, Z:{}", chunkPos.x(), chunkPos.z(), exception);
         }
         return this.empty;
     }
@@ -404,13 +405,13 @@ public class ChunkProviderThreaded implements IChunkProvider {
             }
         }
 
-        public void queueChunk(@NotNull ChunkPos chunkPos) {
+        public void queueChunk(@NotNull ChunkPosc chunkPos) {
             synchronized (this.chunkProvider.preparedUndecoratedChunks) {
                 if (this.chunkProvider.preparedUndecoratedChunks.containsKey(chunkPos)) return;
             }
             synchronized (this.chunkQueueSet) {
                 if (!this.chunkQueueSet.contains(chunkPos)) {
-                    this.chunkQueueSet.add(chunkPos);
+                    this.chunkQueueSet.add(new ChunkPos(chunkPos));
                 } else {
                     return;
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java b/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
index 15b9f388b..8678031b7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
+++ b/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
@@ -79,7 +79,7 @@ public class SpawnerConfig {
         }
     }
 
-    public static SpawnerConfig createFromTag(CompoundTag tag) {
+    public static @NotNull SpawnerConfig createFromTag(CompoundTag tag) {
         SpawnerConfig config = new SpawnerConfig();
         if (tag != null) {
             config.readFromTag(tag);
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java
index e28b80a18..4ed7fd55b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java
@@ -249,9 +249,9 @@ public final class LevelGenerator {
     }
 
     public static void generateHouse(@NotNull World world) {
-        int xSpawn = world.getLevelData().getSpawnX();
-        int ySpawn = world.getLevelData().getSpawnY();
-        int zSpawn = world.getLevelData().getSpawnZ();
+        int xSpawn = world.getLevelData().getSpawnPos().x();
+        int ySpawn = world.getLevelData().getSpawnPos().y();
+        int zSpawn = world.getLevelData().getSpawnPos().z();
 
         for (int x = xSpawn - 3; x <= xSpawn + 3; x++) {
             for (int y = ySpawn - 2; y <= ySpawn + 2; y++) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java
index 2452ce03e..e4ecc9a6a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java
@@ -116,7 +116,7 @@ public abstract class TerrainGeneratorLerp
                             for (int zInBlob = 0; zInBlob < zBlocksPerBlob; zInBlob++) {
                                 // Determine the coordinates for the block within the blob.
                                 int blockX = xInBlob + blobX * xBlocksPerBlob;
-                                int blockY = yInBlob + blobY * yBlocksPerBlob + this.world.worldType.getMinY();
+                                int blockY = yInBlob + blobY * yBlocksPerBlob + this.world.getWorldType().getMinY();
                                 int blockZ = zInBlob + blobZ * zBlocksPerBlob;
 
                                 int id = getBlockAt(chunk, blockX, blockY, blockZ, zLerpDensity);
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index ec2dbef7a..a0dbfe1c9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -605,12 +605,12 @@ public class ChunkDecoratorOverworld
                 int dy = this.world.getHeightValue(dx, dz);
                 Biome localBiome = this.world.getBlockBiome(dx, dy, dz);
 
-                if ((localBiome.hasSurfaceSnow() || this.world.worldType == WorldTypes.OVERWORLD_WINTER) && dy > 0 && dy < this.world.getHeightBlocks()) {
+                if ((localBiome.hasSurfaceSnow() || this.world.getWorldType() == WorldTypes.OVERWORLD_WINTER) && dy > 0 && dy < this.world.getHeightBlocks()) {
                     if (this.world.isAirBlock(dx, dy, dz) && this.world.getBlockMaterial(dx, dy - 1, dz).blocksMotion()) {
                         this.world.setBlockWithNotify(dx, dy, dz, Blocks.LAYER_SNOW.id());
                     }
                 }
-                if ((localBiome.hasSurfaceIce() || this.world.worldType == WorldTypes.OVERWORLD_WINTER) && (this.world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_STILL.id() || this.world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_FLOWING.id())) {
+                if ((localBiome.hasSurfaceIce() || this.world.getWorldType() == WorldTypes.OVERWORLD_WINTER) && (this.world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_STILL.id() || this.world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_FLOWING.id())) {
                     this.world.setBlockWithNotify(dx, oceanY - 1, dz, Blocks.ICE.id());
                 }
 
